/*******************************************************************************
 *
 * Copyright (c) 2011, 2016 OpenWorm.
 * http://openworm.org
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the MIT License
 * which accompanies this distribution, and is available at
 * http://opensource.org/licenses/MIT
 *
 * Contributors:
 *      OpenWorm - http://openworm.org/people.html
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
 * USE OR OTHER DEALINGS IN THE SOFTWARE.
 *******************************************************************************/

define(function (require) {
    function loadCss(url) {
        var link = document.createElement("link");
        link.type = "text/css";
        link.rel = "stylesheet";
        link.href = url;
        document.getElementsByTagName("head")[0].appendChild(link);
    }

    loadCss("geppetto/js/components/dev/foregroundcontrols/foregroundcontrols.css");

    var React = require('react');

    var SpotlightButton = require('./buttons/SpotlightButton');
    var ControlPanelButton = require('./buttons/ControlPanelButton');
    var QueryBuilderButton = require('./buttons/QueryBuilderButton');
    var TutorialButton = require('./buttons/TutorialButton');

    var GEPPETTO = require('geppetto');

    var ForegroundControls = React.createClass({

    	getInitialState: function () {
            return {
                disableSpotlight: false,
                showDropDown : false
            }
        },

        componentDidMount: function () {

        	
        },

        componentWillMount: function () {
            GEPPETTO.ForegroundControls = this;
        },

        refresh: function(){
            this.forceUpdate();
        },

        render: function () {
            var spotlightBtn = GEPPETTO.Spotlight != undefined ? React.createFactory(SpotlightButton)({disabled: this.state.disableSpotlight}) : '';
            var controlPanelBtn = GEPPETTO.ControlPanel != undefined ? React.createFactory(ControlPanelButton)({}) : '';

            var queryBuilderBtn = GEPPETTO.QueryBuilder != undefined ? React.createFactory(QueryBuilderButton)({}) : '';

            var tutorialBtn = GEPPETTO.Tutorial != undefined ? React.createFactory(TutorialButton)({}) : '';


            return <div className={'foreground-controls'}>
                {controlPanelBtn}
                <br/>
                {spotlightBtn}

                {queryBuilderBtn==""? '': <br />}
                {queryBuilderBtn}

                <br/>
                {tutorialBtn}

            </div>
        }
    });

    return ForegroundControls;
});
